/* Mini Jim shell for testing statically-built extensions. */

#include <stdio.h>
#include <jim.h>


extern int PACKAGE_INIT(Jim_Interp *);


int main (int argc, char *argv[]) {
	Jim_Interp *interp;
	Jim_Obj *jargv;
	int i;
	int res;
	int ret = 0;

	if (argc < 2) return 0;

	interp = Jim_CreateInterp();
	Jim_RegisterCoreCommands(interp);
	Jim_InitStaticExtensions(interp);


	PACKAGE_INIT(interp);


	Jim_SetVariableStrWithStr(interp, "jim::argv0", argv[0]);	
	Jim_SetVariableStrWithStr(interp, JIM_INTERACTIVE, "0"); /* Not sure if needed */

	Jim_SetVariableStr(interp, "argv0", Jim_NewStringObj(interp, argv[1], -1));
	jargv = Jim_NewListObj(interp, NULL, 0);
	for (i = 0; i < argc-2; i++) {
		Jim_ListAppendElement(interp, jargv, Jim_NewStringObj(interp, argv[i+2], -1));
	}
	Jim_SetVariableStr(interp, "argv", jargv);
	Jim_SetVariableStr(interp, "argc", Jim_NewIntObj(interp, i));

	res = Jim_EvalFile(interp, argv[1]);

	if (res != JIM_OK) {
		Jim_MakeErrorMessage(interp);
		fprintf(stderr, "%s\n", Jim_GetString(Jim_GetResult(interp), NULL));
		ret = 1;
	}

	Jim_FreeInterp(interp);

	return ret;
}

/* EOF */
